Attribute VB_Name = "Sample"
'*****************************************************************************
'* check47.frm
'*
'* aISA-R47
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/26
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************
Option Explicit

Private Const szName = "aISA-R47"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long                ' DLL̃o[W
    Dim dwDrvVer As Long                ' Driver̃o[W
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim InValue As Byte                 ' o̓f[^
    Dim OutValue As Byte
    Dim ri As AISA47RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa47.dll ̎gp錾
    If Aisa47wDllOpen() = False Then
        ErrorMessage (AISA47_SLOT_AUTO)
        Exit Sub                ' aisa47.dll ̃[hɎs܂B
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa47wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-R47DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA47_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-R47̎gp錾
    wLogSlot = AISA47_SLOT_AUTO     ' gp̃foCXT܂B
    bResult = Aisa47wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA47_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-R47 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa47wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szName + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 0ɔCӂ̃f[^o
    ' &HAA -> 10101010
    OutValue = &HAA

    If Aisa47wOutPort(wLogSlot, AISA47_PORT_0, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 0 փf[^o" + Chr(10) + _
             "Port 0 Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 0 f[^ǂݍ
    InValue = &H0

    If Aisa47wInPort(wLogSlot, AISA47_PORT_0, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 0 f[^" + Chr(10) + _
             "Port 0 In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-R47̎gpJ
    If Aisa47wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-R47 Closed")

'---------------------------------------------------------------------------
    ' aisa47.dll̎gpJ
    If Aisa47wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa47.dll ̃A[hɎs܂B
    End If

End Sub

'---------------------------------------------------------------------------
' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa47wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA47_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA47_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-R47 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
